#include "variables.h"


/*not currently adiabatic!*/


static 	arySp 	Cv; 	/*vapor concentration molec cm-3*/
	aryDp 		Dp,SaltNp; 	/*ln-mean diameter*/
 	aryDpTp 	Np; 	/*particle number concentration cm-3*/
 	aryDpSpTp 	Mp; 	/*particle mass concentration cm-3*/
	aryDpTp		Mph2o100, dMph2o, exclude, reldMh2o;
static	double 		t; 	/* time hr*/
static	struct dataProf	*Met;
static  struct dataInit *Init;
static	int 		MetDim,AltIndex,CaseDim,CaseIndex=0;

int i,h; 	/* dummy Sponent variable */
int j,k;	/*dummy DpSection variable */

  	arySp 		dCvdt;
  	aryDpTp 	dNpdt;
	aryDpSpTp 	dMpdt;

double		Tcycle,Pgrown,Ht,delT=dt;
double		DryFraction,SizeRatio;
double 		rflux,wetnuclmass,rnuclv,rnuclp,rcondv,rcondp;
double		wetpmass,rcoagadd,rcoagsub,rdepn,rsalt;
double		Rh=0,lastRh=0,h2oMin,h2oMax,h2oTol,SoluteMass, NewWater, BaseT, BaseLWC, mu=0, sign;
double          Rair= 287, roa, oldFm, dFmdz, oldT, dlnrodt, dlnJradius, oldpres, Jentrain, Jradius, dvdz, oldv, oldUpDraft, dlnWdt;
double		evapamt, actualRh, actualRh2, totdMph2o, a, b, T, Tw, dDdtevap, Dpw, Dv, eta, Ml, gammaevap, DepVelocity, Cc, olddDdtevap, dDfactor;
int		Flag, flagRh100 = 1, flagevap = 1, increaseflag, decreaseflag, dDdtflag;
int 		OutputIndex=0;
int 		RisingFlag,Ncycle;
clock_t 	runstart,runfinish;
double 		runtime;
FILE            *RateFilePtr,*GrowthFilePtr;
word24          RateFileName, GrowthFileName;
double          oldTotNum, oldTotMass, TotNum, TotMass, rcondptest;

int		CycleFlag = 0;
double		Le, cp = 1004; /*specific heat J/(kg K)*/
double		LWC0, LWC1, dLWC, WlMR, dWlMR, AirDen = 0.0012;/*g/cc*/

double ParcelTemp, UpDraft, dTemp, dUpDraft;

main()
{
runstart=clock();
/* f_init(); */


Init=ReadInit(&CaseDim);
Met= ReadMet(&MetDim);
ReadMp(Mp);

for (i=0;i<DpDIM;i++) {
  for (k=0;k<TpDIM;k++){
    printf("i%dk%d Mp ",i,k);
    for (j=0;j<SpDIM;j++) printf("%e ",Mp[i][j][k]);
    printf("\n");}}
CalcNp(Np,Mp);
ReadSaltNp(SaltNp);
ReadCv(Cv);

strcpy(RateFileName,"Rates");
strcat(RateFileName,OUTsuffix);
strcpy(GrowthFileName,"Growth");
strcat(GrowthFileName,OUTsuffix);

RateFilePtr=fopen(RateFileName,"w");
fclose(RateFilePtr);
GrowthFilePtr=fopen(GrowthFileName,"w");
fclose(GrowthFilePtr);

Tcycle=Init[CaseIndex].height/Init[CaseIndex].updraft;

RisingFlag=1;
Ht=0;
Ncycle=0;
if (profFLAG==1) {AltIndex=0;}
else {AltIndex=MetDim-1; }
Cv[so2SP]=Init[CaseIndex].so2*MolWt(so2SP)
 *perBIL/(RGAS*(Met[AltIndex].temp/Met[AltIndex].pres)*CCperM3); /*ppb to g/cc*/
Cv[dmsSP]= dmsINIT*MolWt(dmsSP)*
 perTRIL/(RGAS*(Met[AltIndex].temp/Met[AltIndex].pres)*CCperM3); /*ppt to g/cc*/
Cv[h2so4SP]=h2so4INIT*MolWt(h2so4SP)*
 perTRIL/(RGAS*(Met[AltIndex].temp/Met[AltIndex].pres)*CCperM3); /*ppt to g/cc*/


ParcelTemp=Met[AltIndex].temp;
UpDraft = Init[CaseIndex].updraft;

 


for (t=0; t<(endt+dt);)
{
LWC0=LiqWaterContent(Mp);

Ht+=(delT*UpDraft);
if ((RisingFlag==-1)&&(Ht<0)) {RisingFlag=1; Ncycle++;}
/*if ((RisingFlag==1)&&(Ht>Init[CaseIndex].height)) {RisingFlag=-1;}*/
while ((Ht>Met[AltIndex].alt)&&(RisingFlag==1)) {AltIndex+=profFLAG;}
while ((Ht<Met[AltIndex].alt)&&(RisingFlag==-1)) {AltIndex-=profFLAG;}
lastRh=Rh;

if ((Ht>Init[CaseIndex].base)||(Rh>0.999)) {
        delT=dt/10.;
        Met[AltIndex].temp = ParcelTemp;
        }
else{
        delT=dt;
        ParcelTemp=Met[AltIndex].temp+0;
        }
if (Rh>0.999) {delT=.02/UpDraft;}

/*kjs find T and LWC for cloud base*/
//if (Ht<Init[CaseIndex].base){
if((Rh <= 1)&(Ht<Init[CaseIndex].base)){
BaseT = Met[AltIndex].temp;
BaseLWC = LiqWaterContent(Mp);}
/*kjs*/
Rh= RelHumidity(Met[AltIndex],Init[CaseIndex],Mp,BaseT,BaseLWC);/*kjs add BaseT and BaseLWC*/
Cv[h2oSP]=Rh*h2oSatWv(Met[AltIndex].temp);
ReportMet(OutputIndex,t,Ht,Met[AltIndex].temp,Met[AltIndex].pres,Rh,LiqWaterContent(Mp), ParcelTemp, UpDraft);



printf("t=%f loop Ht%e %f %d %e RH%e %e %e \n",t,Ht,Met[AltIndex].alt,AltIndex,Cv[h2oSP],Rh,Met[AltIndex].temp,Init[CaseIndex].maxlwc);

  for (k=0;k<TpDIM;k++) 
  {
    for (i=0; i<DpDIM; i++)
    {

      for (j=0; j<SpDIM; j++)
      { 
        if (Mp[i][j][k]<=0) {Mp[i][j][k]=0;}
        if ((j==h2oSP)&&(Rh<1.)) {
          SoluteMass=drySMass(i,k,Mp);
          if (SoluteMass>0) {
              h2oMin=(1./LWCfactor)*Mp[i][h2oSP][k]; 
              h2oMax=LWCfactor*Mp[i][h2oSP][k];
              h2oTol=tolLWC*SoluteMass;
/*printf("test1 h2otol%e tollwc%e Solutemass%e \n", h2oTol, tolLWC, SoluteMass);*/
            if (h2oMax<zeroTHRESH) {Mp[i][h2oSP][k]=minLWC*SoluteMass;}
            else {
/*printf("test2 h2omin%e h2omax%e h2otol%e Cv[h2osp]%e \n",
        h2oMin, h2oMax, h2oTol, Cv[h2oSP]);*/

              Mp[i][h2oSP][k]=zbrent(Equilibrium,h2oMin,h2oMax,h2oTol,
              Cv[h2oSP],i,k,Mp,Np[i][k],Met[AltIndex]);}
            if (Mp[i][h2oSP][k]<0.)  {
              h2oMin=minLWC*SoluteMass; 
              h2oMax=maxLWC*SoluteMass;
              Mp[i][h2oSP][k]=zbrent(Equilibrium,h2oMin,h2oMax,h2oTol,
              Cv[h2oSP],i,k,Mp,Np[i][k],Met[AltIndex]);
           	   if (Mp[i][h2oSP][k]<0.)  {
               		printf("Eq root failed\n");
                	Mp[i][h2oSP][k]=minLWC*SoluteMass;}}

          rcondv=0;
          rcondp=0;}}
        else {
	  if ((UpDraft>0)&&(Rh>1)){
            rcondv=Rcond(i,j,k,vaporTP,Mp,Cv,Np[i][k],Met[AltIndex]);
            rcondp= Rcond(i,j,k,0,Mp,Cv,Np[i][k],Met[AltIndex]);
	  if ((rcondp<0)&&(wetDp(i,k,Mp[i][h2oSP][k],Mp,Np[i][k]>5))){
		rcondv=0;
		rcondp=0;}
	  }   
          else{


            rcondv = 0;
            rcondp = 0;}
        }
	  
        

NewWater = Mp[i][h2oSP][k];
/*this was in old code but in rates.c (KJS)*/
	if ((j==h2oSP)&&(rcondp<0)&&(Cv[h2oSP]>h2oSatWv(Met[AltIndex].temp))) {
          SoluteMass=drySMass(i,k,Mp);
          if (SoluteMass>0) {
              h2oMin=(1./LWCfactor)*Mp[i][h2oSP][k]; 
              h2oMax=LWCfactor*Mp[i][h2oSP][k];
              h2oTol=tolLWC*SoluteMass;
/*printf("test4 h2omin%e h2omax%e h2otol%e Cv[h2osp]%e \n",
        h2oMin, h2oMax, h2oTol, Cv[h2oSP]);*/
            if (h2oMax<zeroTHRESH) {Mp[i][h2oSP][k]=minLWC*SoluteMass;}
            else {
              NewWater =zbrent(Equilibrium,h2oMin,h2oMax,h2oTol,
              		Cv[h2oSP],i,k,Mp,Np[i][k],Met[AltIndex]);
	      rcondp = NewWater - Mp[i][h2oSP][k];}
/*printf("test5 rcondp%e \n",rcondp);*/
            if (NewWater<0.)  {
              h2oMin=minLWC*SoluteMass; 
              h2oMax=maxLWC*SoluteMass;
              NewWater=zbrent(Equilibrium,h2oMin,h2oMax,h2oTol,
              		Cv[h2oSP],i,k,Mp,Np[i][k],Met[AltIndex]);
	      rcondp = NewWater - Mp[i][h2oSP][k];
/*printf("test6 rcondv%e rcondp%e h2omin%e h2omax%e h2otol%e Cv[h2osp]%e \n",
        rcondv, rcondp, h2oMin, h2oMax, h2oTol, Cv[h2oSP]);*/
                   if (NewWater<0.)  {
                        printf("Eq root failed\n");
			rcondp = (minLWC*SoluteMass)-Mp[i][h2oSP][k];}}
/*printf("test7 rcondp%e \n",rcondp);*/
if ((rcondptest < 0) && (rcondp > h2oMin)){rcondp = (minLWC*SoluteMass)-Mp[i][h2oSP][k];
/*printf("test8 rcondp%e \n",rcondp);*/}
	  }
	else  {rcondp+=0;}
	}

if (((rcondp > 0) || (rcondp<0))&&(j == 0)){
printf("rcondtesting rcondp%e \n",rcondp);

}
/*KJS*/

          rflux= Rflux(j,Cv,t,Met[AltIndex],Init[CaseIndex]);
          rnuclv= Rnucl(i,j,vaporTP,Cv,Met[AltIndex]);
          rnuclp= Rnucl(i,j,k,Cv,Met[AltIndex]);
          rcoagadd=RcoagAdd(i,j,k,Mp,Np,Met[AltIndex]);
          rcoagsub=RcoagSub(i,j,k,Mp,Np,Met[AltIndex]);
/*printf("Main t%f i%dj%dk%d add%e sub%e\n",t,i,j,k,rcoagadd,rcoagsub);*/

        rdepn=Rdepn(i,j,k,Mp,Np[i][k],Met[AltIndex],Init[CaseIndex]);
        rsalt=Rsalt(i,j,k,SaltNp,Met[AltIndex],Init[CaseIndex]);
        wetpmass=wetPMass(i,k,Mp[i][h2oSP][k],Mp,Np[i][k]);
        wetnuclmass=wetNuclMass(Cv,Met[AltIndex]);
    
        dCvdt[j]+=( rflux-wetnuclmass*rnuclv-rcondv );
        dNpdt[i][k]+=( rnuclp+rcoagadd-rcoagsub-rdepn+rsalt );
        dMpdt[i][j][k]=wetnuclmass*rnuclp+rcondp
         +wetpmass*(rcoagadd-rcoagsub-rdepn+rsalt);/*old main.c has coagadd not in ()*/

if (t>=dtOUT*OutputIndex) {
  RateFilePtr=fopen(RateFileName,"a");
fprintf(RateFilePtr,"t%f i%dj%dk%d %e %e %e %e %e %e %e %e %e %e %e %e %e %e %e %e\n",t,i,j,k,
   wetnuclmass,wetpmass,rflux,rnuclv,rcondv, rnuclp,rcoagadd,rcoagsub,
   rdepn,rsalt,rcondp,dCvdt[j],dNpdt[i][k],dMpdt[i][j][k], 
   Activity(j,k,i,Mp[i][h2oSP][k],Mp,Np[i][k],Met[AltIndex]), Surface(i,k,Mp[i][h2oSP][k],Mp,Np[i][k],Met[AltIndex]));
  fclose(RateFilePtr);}

      }  /*end j Loop*/
  } }  /*end i,k Loops*/

for (j=0;j<SpDIM;j++) { 
  if (!(j==h2oSP)) {Cv[j]+=( dCvdt[j]*delT ); }  
  dCvdt[j]=0.;
  if (Cv[j]<0) {Cv[j]=0;}
  printf("Cv j%d %e\n",j,Cv[j]); }

for (i=0;i<DpDIM;i++) {
  for (k=0;k<TpDIM;k++) {
if (t>=dtOUT*OutputIndex) {
GrowthFilePtr=fopen(GrowthFileName,"a");
fprintf(GrowthFilePtr,"dt%f i%dk%d dN%e del%f oldNp%e  ",t,i,k,dNpdt[i][k],delT,Np[i][k]);}
    Np[i][k]+=(dNpdt[i][k]*delT); 
    Np[i][k] = Np[i][k];/*oldv/(4/3*PI*pow(Jradius,3)); /*dilute with parcel expansion*/
    if (Np[i][k]<=0) {Np[i][k]=0;}
if (t>=dtOUT*OutputIndex) {
fprintf(GrowthFilePtr," newNp%e\n",Np[i][k]);
fclose(GrowthFilePtr);}
    dNpdt[i][k]=0.;
    for (j=0;j<SpDIM;j++) { 
      Mp[i][j][k]+=( dMpdt[i][j][k]*delT );
      Mp[i][j][k] = Mp[i][j][k];/*oldv/(4/3*PI*pow(Jradius,3)); /*dilute with parcel expansion*/
      if (Mp[i][j][k]<=0) {Mp[i][j][k]=0;}
/* Check to see that gas-Mps are 0 */
      if ((j==so2SP)|(j==dmsSP)) {Mp[i][j][k]=0;}
/* Check to see if mass has condensed onto particles which fell out: */
      if ((Mp[i][j][k]>0)&&(Np[i][k]==0)) {Mp[i][j][k]=0;}   }}}

oldTotNum=0; oldTotMass=0;
for (i=0;i<DpDIM;i++) {
  for (k=0;k<TpDIM;k++){
    oldTotNum+=Np[i][k];
    for (j=0;j<SpDIM;j++) { oldTotMass+=Mp[i][j][k];}}}

Pgrown= Rgrow(Mp,Np);

TotNum=0;TotMass=0;
for (i=0;i<DpDIM;i++) {
  for (k=0;k<TpDIM;k++){
    TotNum+=Np[i][k];
    for (j=0;j<SpDIM;j++) { TotMass+=Mp[i][j][k];}}}


if (t>=dtOUT*OutputIndex) {
GrowthFilePtr=fopen(GrowthFileName,"a");
fprintf(GrowthFilePtr,"t%f oldN%e N%e oldM%e M%e\n",t,oldTotNum,TotNum,oldTotMass,TotMass);
fclose(GrowthFilePtr);}


for (i=0;i<DpDIM;i++) {
  for (k=0;k<TpDIM;k++){
    Flag=0;
    for (j=0;j<SpDIM;j++) { 
      SizeRatio= dryPMass(i,k,Mp)/(dryPDensity(i,k,Mp)*PI*pow(dryDp(i),3.0)/6.);
      DryFraction = dryPMass(i,k,Mp)
       /wetPMass(i,k,Mp[i][h2oSP][k],Mp,Np[i][k]);
      if (Mp[i][j][k]>0) {Flag=1;}
      if (!(Cv[j]>=0)) {printf("Cv<0 t%f j%d %e\n",t,j,Cv[j]); }}
    if ((Flag==0)&&(Np[i][k]>0)) {
      printf("Np>Mp=0 t%f i%d j%d k%d %e %e\n",t,i,j,k,Mp[i][j][k],Np[i][k]);}
} }

if (t>=dtOUT*OutputIndex) {
  ReportCv(OutputIndex,t,Cv);
  ReportNp(OutputIndex,t,Np);
  ReportMp(OutputIndex,t,Mp);
  ReportDp(OutputIndex,t,Mp,Np);
  OutputIndex++;}
t+=delT;



/*updraft kjs*/
LWC1=LiqWaterContent(Mp);
Le = 2.26E6; /*J/kg*/
/*Le=597.3*pow((ZEROC/T),(0.167+3.67e-4*T))*JperCAL; /*ITcal/g -> J/g specific latent heat from Pruppacher and Klett*/
dLWC = LWC1-LWC0; /*g/cc*/
dWlMR = dLWC/AirDen;/*g/g*/
WlMR = LWC1/AirDen;/*g/g*/
/*equation calls for dwvMR which = -dwlMR so change signs in dTemp equation*/
dTemp = -delT*(UpDraft*(GRAVITY)-Le*dWlMR/delT+mu*fabs(UpDraft)*(-Le*0/*WlMR-WlMRbg*/+(ParcelTemp-Met[AltIndex].temp)*cp))/cp;/*the commented part should be difference from background*/
//ParcelTemp = ParcelTemp + dTemp;

if (UpDraft > 0) sign = 1; else sign = -1;

dUpDraft = delT*((GRAVITY*((ParcelTemp-Met[AltIndex].temp)/(Met[AltIndex].temp+ZEROC)-WlMR))-sign*mu*UpDraft*UpDraft)*2/3;

//UpDraft += dUpDraft;
printf("dT%e dU%e parcelT%e T%e\n",dTemp, dUpDraft, ParcelTemp, Met[AltIndex].temp);

if (UpDraft<0) RisingFlag=-1; else RisingFlag=1;
if (UpDraft<0) CycleFlag++;
/*if ((UpDraft>0)&&(CycleFlag>0)) break;*/
/*if (UpDraft <0) break;*/
/*updraft kjs*/

} /*end t Loop*/

runfinish=clock();
runtime=(double) (runfinish-runstart)/CLOCKS_PER_SEC;
printf("Runtime %lf sec.\n",runtime);
} /*end main*/

